Index: stream/stream_dvd.c
===================================================================
--- stream/stream_dvd.c	(revision 27458)
+++ stream/stream_dvd.c	(working copy)
@@ -1081,6 +1081,7 @@
 
 static int ifo_stream_open (stream_t *stream, int mode, void *opts, int *file_format)
 {
+#ifndef GEKKO
     char *ext;
     char* filename;
     struct stream_priv_s *spriv;
@@ -1107,6 +1108,9 @@
     stream->url=strdup("dvd://");
 
     return open_s(stream, mode, spriv, file_format);
+#else
+    return STREAM_UNSUPPORTED;
+#endif
 }
 
 const stream_info_t stream_info_dvd = {
Index: stream/stream.c
===================================================================
--- stream/stream.c	(revision 27458)
+++ stream/stream.c	(working copy)
@@ -5,12 +5,14 @@
 
 #include <sys/types.h>
 #include <sys/stat.h>
-#ifndef __MINGW32__
+#if !defined (__MINGW32__) && !defined (GEKKO)
 #include <sys/ioctl.h>
 #include <sys/wait.h>
 #endif
 #include <fcntl.h>
+#ifndef GEKKO
 #include <strings.h>
+#endif
 
 #include "config.h"
 
Index: libao2/ao_mpegpes.c
===================================================================
--- libao2/ao_mpegpes.c	(revision 27458)
+++ libao2/ao_mpegpes.c	(working copy)
@@ -149,6 +149,8 @@
 		mp_msg(MSGT_VO, MSGL_ERR, "AO_MPEGPES, Unrecognized options\n");
 		return -1;
 	}
+
+#ifdef HAVE_DVB_HEAD
 	if(card==-1)
 	{
 		//search the first usable card
@@ -164,6 +166,8 @@
 			}
         	}
 	}
+#endif
+
 	if((card < 1) || (card > 4))
 	{
 		mp_msg(MSGT_VO, MSGL_ERR, "DVB card number must be between 1 and 4\n");
Index: libao2/ao_gekko.c
===================================================================
--- libao2/ao_gekko.c	(revision 0)
+++ libao2/ao_gekko.c	(revision 0)
@@ -0,0 +1,177 @@
+/*
+   ao_gekko.c - MPlayer audio driver for Wii
+
+   Copyright (C) 2008 dhewg
+
+   This library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2 of the License, or (at your option) any later version.
+
+   This library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with this library; if not, write to the
+   Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+   Boston, MA 02110-1301 USA.
+*/
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+#include "config.h"
+#include "libaf/af_format.h"
+#include "audio_out.h"
+#include "audio_out_internal.h"
+#include "mp_msg.h"
+#include "help_mp.h"
+
+#include <ogcsys.h>
+
+static ao_info_t info = {
+	"gekko audio output",
+	"gekko",
+	"Team Twiizers",
+	""
+};
+
+LIBAO_EXTERN(gekko)
+
+#define SFX_BUFFER_SIZE (8*1024)
+#define SFX_BUFFERS 32
+
+static u8 buffer[SFX_BUFFERS][SFX_BUFFER_SIZE] ATTRIBUTE_ALIGN(32);
+static u8 buffer_fill = 0;
+static u8 buffer_play = 0;
+static u8 buffer_free = SFX_BUFFERS;
+static bool playing = false;
+
+static void switch_buffers() {
+	AUDIO_StopDMA();
+
+	if (playing)
+		buffer_free++;
+
+	if (buffer_free == SFX_BUFFERS) {
+		playing = false;
+		return;
+	}
+
+	AUDIO_InitDMA((u32) buffer[buffer_play], SFX_BUFFER_SIZE);
+	AUDIO_StartDMA();
+
+	buffer_play = (buffer_play + 1) % SFX_BUFFERS;
+
+	playing = true;
+}
+
+static int control(int cmd, void *arg) {
+	//mp_msg(MSGT_AO, MSGL_ERR, "[AOGEKKO]: control %d\n", cmd);
+
+	return CONTROL_UNKNOWN;
+}
+
+static int init(int rate, int channels, int format, int flags) {
+	AUDIO_SetDSPSampleRate(AI_SAMPLERATE_48KHZ);
+	AUDIO_RegisterDMACallback(switch_buffers);
+
+	ao_data.buffersize = SFX_BUFFER_SIZE * SFX_BUFFERS;
+	ao_data.outburst = SFX_BUFFER_SIZE;
+	ao_data.channels = 2;
+	ao_data.samplerate = 48000;
+	ao_data.format = AF_FORMAT_S16_BE;
+	ao_data.bps = 192000;
+
+	return 1;
+}
+
+static void reset(void) {
+	u8 i;
+
+	AUDIO_StopDMA();
+
+	for (i = 0; i < SFX_BUFFERS; ++i) {
+		memset(buffer[i], 0, SFX_BUFFER_SIZE);
+		DCFlushRange(buffer[i], SFX_BUFFER_SIZE);
+	}
+
+	buffer_fill = 0;
+	buffer_play = 0;
+	buffer_free = SFX_BUFFERS;
+
+	playing = false;
+}
+
+static void uninit(int immed) {
+	reset();
+
+	AUDIO_RegisterDMACallback(NULL);
+}
+
+static void audio_pause(void) {
+	AUDIO_StopDMA();
+
+	if (playing && (buffer_free < SFX_BUFFERS)) {
+		buffer_play = (buffer_play + 1) % SFX_BUFFERS;
+		buffer_free++;
+	}
+
+	playing = false;
+}
+
+static void audio_resume(void) {
+	switch_buffers();
+}
+
+static int get_space(void) {
+	return (buffer_free - 1) * SFX_BUFFER_SIZE;
+}
+
+static int play(void* data, int len, int flags) {
+	int bl, ret = 0;
+	u8 *s = (u8 *) data;
+
+	while ((len > 0) && (buffer_free > 1)) {
+		bl = len;
+		if (bl > SFX_BUFFER_SIZE)
+			bl = SFX_BUFFER_SIZE;
+
+		memcpy(buffer[buffer_fill], s, bl);
+
+		if (bl < SFX_BUFFER_SIZE)
+			memset(buffer[buffer_fill] + bl, 0, SFX_BUFFER_SIZE - bl);
+
+		DCFlushRange(buffer[buffer_fill], bl);
+
+		buffer_fill = (buffer_fill + 1) % SFX_BUFFERS;
+		buffer_free--;
+
+		len -= bl;
+		s += bl;
+		ret += bl;
+	}
+
+	if (!playing)
+		switch_buffers();
+
+	return ret;
+}
+
+static float get_delay(void) {
+	float b;
+
+	if (buffer_free == SFX_BUFFERS)
+		return 0;
+
+	b = (SFX_BUFFERS - buffer_free) * SFX_BUFFER_SIZE;
+
+	if (playing)
+		b += AUDIO_GetDMABytesLeft();
+
+	return b / 192000.0f;
+}
+
Index: libao2/audio_out.c
===================================================================
--- libao2/audio_out.c	(revision 27458)
+++ libao2/audio_out.c	(working copy)
@@ -35,6 +35,7 @@
 extern ao_functions_t audio_out_mpegpes;
 extern ao_functions_t audio_out_pcm;
 extern ao_functions_t audio_out_pss;
+extern ao_functions_t audio_out_gekko;
 
 const ao_functions_t* const audio_out_drivers[] =
 {
@@ -95,6 +96,9 @@
 #ifdef CONFIG_V4L2_DECODER
         &audio_out_v4l2,
 #endif
+#ifdef GEKKO
+		&audio_out_gekko,
+#endif
         &audio_out_null,
 // should not be auto-selected:
         &audio_out_pcm,
Index: Makefile
===================================================================
--- Makefile	(revision 27458)
+++ Makefile	(working copy)
@@ -599,6 +599,10 @@
 SRCS_MPLAYER-$(VIDIX_SIS)           += vidix/sis_vid.c vidix/sis_bridge.c
 SRCS_MPLAYER-$(VIDIX_UNICHROME)     += vidix/unichrome_vid.c
 
+SRCS_MPLAYER_PORT-$(GEKKO) = osdep/log_console.c \
+							 osdep/gx_supp.c \
+							 osdep/plat_gekko.c
+
 SRCS_MENCODER = mencoder.c \
                 mp_msg-mencoder.c \
                 parser-mecmd.c \
@@ -628,7 +632,7 @@
 
 SRCS_COMMON   += $(SRCS_COMMON-yes) $(SRCS_COMMON-yes-yes) $(SRCS_COMMON-yes-yes-yes)
 SRCS_MENCODER += $(SRCS_MENCODER-yes)
-SRCS_MPLAYER  += $(SRCS_MPLAYER-yes)
+SRCS_MPLAYER  += $(SRCS_MPLAYER-yes) $(SRCS_MPLAYER_PORT-yes)
 
 COMMON_LIBS-$(LIBAVFORMAT_A)      += libavformat/libavformat.a
 COMMON_LIBS-$(LIBAVCODEC_A)       += libavcodec/libavcodec.a
@@ -649,6 +653,7 @@
 
 ALL_PRG-$(MPLAYER)  += mplayer$(EXESUF)
 ALL_PRG-$(MENCODER) += mencoder$(EXESUF)
+ALL_PRG-$(GEKKO)  += mplayer.dol
 
 INSTALL_TARGETS-$(GUI)      += install-gui
 INSTALL_TARGETS-$(MENCODER) += install-mencoder install-mencoder-man
@@ -718,6 +723,14 @@
 
 all: $(ALL_PRG-yes)
 
+ifeq ($(GEKKO),yes)
+upload: mplayer.dol
+	wiiload mplayer.dol
+
+mplayer.dol: mplayer$(EXESUF)
+	$(OBJCOPY) -O binary mplayer$(EXESUF) mplayer.dol
+endif
+
 %.d: %.c
 	$(MPDEPEND_CMD) > $@
 
@@ -862,6 +875,9 @@
 clean:
 	rm -f $(foreach dir,$(DIRS),$(foreach suffix,/*.o /*.a /*.ho /*~, $(addsuffix $(suffix),$(dir))))
 	rm -f mplayer$(EXESUF) mencoder$(EXESUF)
+ifeq ($(GEKKO),yes)
+	rm -f mplayer.dol
+endif
 
 distclean: clean testsclean toolsclean driversclean dhahelperclean dhahelperwinclean
 	rm -rf DOCS/tech/doxygen
Index: cpudetect.c
===================================================================
--- cpudetect.c	(revision 27458)
+++ cpudetect.c	(working copy)
@@ -486,7 +486,7 @@
 
 #ifdef __APPLE__
 #include <sys/sysctl.h>
-#elif __AMIGAOS4__
+#elif defined(__AMIGAOS4__) || defined (GEKKO)
 /* nothing */
 #else
 #include <signal.h>
Index: mixer.c
===================================================================
--- mixer.c	(revision 27458)
+++ mixer.c	(working copy)
@@ -1,5 +1,5 @@
 #include <string.h>
-#ifndef __MINGW32__
+#if !defined(__MINGW32__) && !defined(GEKKO)
 #include <sys/ioctl.h>
 #endif
 #include <fcntl.h>
Index: mplayer.ld
===================================================================
--- mplayer.ld	(revision 0)
+++ mplayer.ld	(revision 0)
@@ -0,0 +1,388 @@
+/*
+ * Linkscript for GC, automatically sets up DOL structures,
+ * generate ELF file and use objdump, or generate binary
+ * directly.
+ *
+ * PSUL doesn't seem to handle separate text and data sections correctly,
+ * that is why the text and data sections are merged in the header.
+ *
+ * If you want to experiment, it should be quite obvious how to
+ * change the header to list the data separately.
+ */
+
+OUTPUT_FORMAT("elf32-powerpc", "elf32-powerpc", "elf32-powerpc");
+OUTPUT_ARCH(powerpc:common);
+EXTERN(_start);
+ENTRY(_start);
+
+
+SECTIONS
+{
+
+	/* DOL header (from TITANIK's GC docs) */
+	/* default base address */
+	. = 0x80003f00;
+	.header	:
+	{
+		file_start = .;
+		/*    0000-001B  Text[0..6] sections File Positions */
+		LONG(text_file_start);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+
+		/*    001C-0047  Data[0..10] sections File Positions */
+		LONG(data_file_start);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+
+		/*    0048-0063  Text[0..6] sections Mem Address */
+		LONG(text_mem_start);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+
+		/*    0064-008F  Data[0..10] sections Mem Address */
+		LONG(data_mem_start);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+
+		/*    0090-00AB  Text[0..6] sections Sizes */
+		LONG(text_mem_size);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+
+		/*    00AC-00D7  Data[0..10] sections Sizes */
+		LONG(data_mem_size);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+		LONG(0);
+
+		/*	00D8  BSS Mem address
+			00DC  BSS Size */
+		LONG(bss_mem_start);
+		LONG(bss_mem_size);
+
+		/*    00E0  Entry Point */
+		LONG(ABSOLUTE(_start));
+	}
+
+	/* Program */
+	. = file_start + 0x100;
+	text_mem_start = .;
+
+	.init          :
+	{
+		KEEP (*crt0.o(*.init))
+		KEEP (*(.init))
+	} = 0
+	.plt      : { *(.plt)	}
+	.interp			: { *(.interp) 	}
+	.hash			: { *(.hash) }
+	.dynsym			: { *(.dynsym) }
+	.dynstr			: { *(.dynstr) }
+	.gnu.version	: { *(.gnu.version) }
+	.gnu.version_d	: { *(.gnu.version_d) }
+	.gnu.version_r	: { *(.gnu.version_r) }
+	.rel.init		: { *(.rel.init) }
+	.rela.init		: { *(.rela.init) }
+	.rel.text		: { *(.rel.text .rel.text.* .rel.gnu.linkonce.t.*) }
+	.rela.text		: { *(.rela.text .rela.text.* .rela.gnu.linkonce.t.*) }
+	.rel.fini		: { *(.rel.fini) }
+	.rela.fini		: { *(.rela.fini) }
+	.rel.rodata		: { *(.rel.rodata .rel.rodata.* .rel.gnu.linkonce.r.*) }
+	.rela.rodata	: { *(.rela.rodata .rela.rodata.* .rela.gnu.linkonce.r.*) }
+	.rel.data		: { *(.rel.data .rel.data.* .rel.gnu.linkonce.d.*) }
+	.rela.data		: { *(.rela.data .rela.data.* .rela.gnu.linkonce.d.*) }
+	.rel.tdata		: { *(.rel.tdata .rel.tdata.* .rel.gnu.linkonce.td.*) }
+	.rela.tdata		: { *(.rela.tdata .rela.tdata.* .rela.gnu.linkonce.td.*) }
+	.rel.tbss		: { *(.rel.tbss .rel.tbss.* .rel.gnu.linkonce.tb.*) }
+	.rela.tbss		: { *(.rela.tbss .rela.tbss.* .rela.gnu.linkonce.tb.*) }
+	.rel.ctors		: { *(.rel.ctors) }
+	.rela.ctors		: { *(.rela.ctors) }
+	.rel.dtors		: { *(.rel.dtors) }
+	.rela.dtors		: { *(.rela.dtors) }
+	.rel.got		: { *(.rel.got)	}
+	.rela.got		: { *(.rela.got) }
+	.rela.got1		: { *(.rela.got1) }
+	.rela.got2		: { *(.rela.got2) }
+	.rel.sdata		: { *(.rel.sdata .rel.sdata.* .rel.gnu.linkonce.s.*) }
+	.rela.sdata		: { *(.rela.sdata .rela.sdata.* .rela.gnu.linkonce.s.*) }
+	.rel.sbss		: { *(.rel.sbss .rel.sbss.* .rel.gnu.linkonce.sb.*) }
+	.rela.sbss		: { *(.rela.sbss .rela.sbss.* .rel.gnu.linkonce.sb.*) }
+	.rel.sdata2		: { *(.rel.sdata2 .rel.sdata2.* .rel.gnu.linkonce.s2.*) }
+	.rela.sdata2	: { *(.rela.sdata2 .rela.sdata2.* .rela.gnu.linkonce.s2.*) }
+	.rel.sbss2		: { *(.rel.sbss2 .rel.sbss2.* .rel.gnu.linkonce.sb2.*) }
+	.rela.sbss2		: { *(.rela.sbss2 .rela.sbss2.* .rela.gnu.linkonce.sb2.*) }
+	.rel.bss		: { *(.rel.bss .rel.bss.* .rel.gnu.linkonce.b.*) }
+	.rela.bss		: { *(.rela.bss .rela.bss.* .rela.gnu.linkonce.b.*) }
+	.rel.plt		: { *(.rel.plt) }
+	.rela.plt		: { *(.rela.plt) }
+
+	.text      :
+	{
+		*(.text)
+		*(.text.*)
+		*(.stub)
+		/* .gnu.warning sections are handled specially by elf32.em.  */
+		*(.gnu.warning)
+		*(.gnu.linkonce.t.*)
+		. = ALIGN(32);   /* REQUIRED. LD is flaky without it. */
+	} = 0
+
+	.fini      :
+	{
+		KEEP (*(.fini))
+		. = ALIGN(32);   /* REQUIRED. LD is flaky without it. */
+	} = 0
+	
+	PROVIDE (__etext = .);
+	PROVIDE (_etext = .);
+	PROVIDE (etext = .);
+
+	text_mem_size = . - text_mem_start;
+
+	data_mem_start = .;
+	.rodata   : { *(.rodata) *(.rodata.*) *(.gnu.linkonce.r.*) }
+	.rodata1   : { *(.rodata1) }
+	.sdata2   : { *(.sdata2) *(.sdata2.*) *(.gnu.linkonce.s2.*) }
+	.sbss2   : { *(.sbss2) *(.sbss2.*) *(.gnu.linkonce.sb2.*) }
+  /* Adjust the address for the data segment.  We want to adjust up to
+     the same address within the page on the next page up.  */
+  /* Ensure the __preinit_array_start label is properly aligned.  We
+     could instead move the label definition inside the section, but
+     the linker would then create the section even if it turns out to
+     be empty, which isn't pretty.  */
+	. = ALIGN(32 / 8);
+	PROVIDE (__preinit_array_start = .);
+	.preinit_array     : { *(.preinit_array) }
+	PROVIDE (__preinit_array_end = .);
+	PROVIDE (__init_array_start = .);
+	.init_array     : { *(.init_array) }
+	PROVIDE (__init_array_end = .);
+	PROVIDE (__fini_array_start = .);
+	.fini_array     : { *(.fini_array) }
+	PROVIDE (__fini_array_end = .);
+	.data    :
+	{
+		*(.data)
+		*(.data.*)
+		*(.gnu.linkonce.d.*)
+		SORT(CONSTRUCTORS)
+		. = ALIGN(32);   /* REQUIRED. LD is flaky without it. */
+	}
+
+	.data1   : { *(.data1) }
+	.tdata	  : { *(.tdata .tdata.* .gnu.linkonce.td.*) }
+	.tbss		  : { *(.tbss .tbss.* .gnu.linkonce.tb.*) *(.tcommon) }
+	.eh_frame : { KEEP (*(.eh_frame)) }
+	.gcc_except_table : { *(.gcc_except_table) }
+	.fixup          : { *(.fixup) }
+	.got1           : { *(.got1) }
+	.got2           : { *(.got2) }
+	.dynamic       : { *(.dynamic) }
+
+	.ctors   :
+	{
+	/*	gcc uses crtbegin.o to find the start of
+		the constructors, so we make sure it is
+		first.  Because this is a wildcard, it
+		doesn't matter if the user does not
+		actually link against crtbegin.o; the
+		linker won't look for a file to match a
+		wildcard.  The wildcard also means that it
+		doesn't matter which directory crtbegin.o
+		is in.  */
+
+		KEEP (*crtbegin.o(.ctors))
+
+    /*	We don't want to include the .ctor section from
+		from the crtend.o file until after the sorted ctors.
+		The .ctor section from the crtend file contains the
+		end of ctors marker and it must be last */
+
+		KEEP (*(EXCLUDE_FILE (*crtend.o ) .ctors))
+		KEEP (*(SORT(.ctors.*)))
+		KEEP (*(.ctors))
+		. = ALIGN(32);   /* REQUIRED. LD is flaky without it. */
+	}
+
+	.dtors         :
+	{
+		KEEP (*crtbegin.o(.dtors))
+		KEEP (*(EXCLUDE_FILE (*crtend.o ) .dtors))
+		KEEP (*(SORT(.dtors.*)))
+		KEEP (*(.dtors))
+		. = ALIGN(32);   /* REQUIRED. LD is flaky without it. */
+	}
+
+	.jcr            : { KEEP (*(.jcr)) }
+	.got		  : { *(.got.plt) *(.got) }
+
+
+	/*	We want the small data sections together, so single-instruction offsets
+		can access them all, and initialized data all before uninitialized, so
+		we can shorten the on-disk segment size.  */
+
+	.sdata     :
+	{
+		*(.sdata)
+		*(.sdata.*)
+		*(.gnu.linkonce.s.*)
+		. = ALIGN(32);   /* REQUIRED. LD is flaky without it. */
+	}
+
+	_edata = .;
+	PROVIDE (edata = .);
+
+	data_mem_size = . - data_mem_start;
+
+	bss_mem_start = .;
+	.sbss      :
+	{
+		__sbss_start = .;
+		PROVIDE (__sbss_start = .);
+		PROVIDE (___sbss_start = .);
+		*(.dynsbss)
+		*(.sbss)
+		*(.sbss.*)
+		*(.gnu.linkonce.sb.*)
+		*(.scommon)
+		PROVIDE (__sbss_end = .);
+		PROVIDE (___sbss_end = .);
+		. = ALIGN(32);   /* REQUIRED. LD is flaky without it. */
+		__sbss_end = .;
+	}
+
+	.bss       :
+	{
+		__bss_start = .;
+		PROVIDE (__bss_start = .);
+		*(.dynbss)
+		*(.bss)
+		*(.bss.*)
+		*(.gnu.linkonce.b.*)
+		*(COMMON)
+	/*	Align here to ensure that the .bss section occupies space up to
+		_end.  Align after .bss to ensure correct alignment even if the
+		.bss section disappears because there are no input sections.  */
+
+		. = ALIGN(32);
+
+		PROVIDE (__bss_end = .);
+		__bss_end = .;
+	}
+ 
+ 	bss_mem_size = . - bss_mem_start;
+
+	/* calculate file addresses */
+	text_file_start = text_mem_start - file_start;
+	data_file_start = data_mem_start - file_start;
+	bss_file_start = bss_mem_start - file_start;
+
+	_end = .;
+	PROVIDE(end = .);
+	/* Stabs debugging sections.  */
+	.stab 0 : { *(.stab) }
+	.stabstr 0 : { *(.stabstr) }
+	.stab.excl 0 : { *(.stab.excl) }
+	.stab.exclstr 0 : { *(.stab.exclstr) }
+	.stab.index 0 : { *(.stab.index) }
+	.stab.indexstr 0 : { *(.stab.indexstr) }
+	.comment 0 : { *(.comment) }
+	/*	DWARF debug sections.
+		Symbols in the DWARF debugging sections are relative to the beginning
+		of the section so we begin them at 0.  */
+	/* DWARF 1 */
+	.debug          0 : { *(.debug) }
+	.line           0 : { *(.line) }
+	/* GNU DWARF 1 extensions */
+	.debug_srcinfo  0 : { *(.debug_srcinfo) }
+	.debug_sfnames  0 : { *(.debug_sfnames) }
+	/* DWARF 1.1 and DWARF 2 */
+	.debug_aranges  0 : { *(.debug_aranges) }
+	.debug_pubnames 0 : { *(.debug_pubnames) }
+	/* DWARF 2 */
+	.debug_info     0 : { *(.debug_info) }
+	.debug_abbrev   0 : { *(.debug_abbrev) }
+	.debug_line     0 : { *(.debug_line) }
+	.debug_frame    0 : { *(.debug_frame) }
+	.debug_str      0 : { *(.debug_str) }
+	.debug_loc      0 : { *(.debug_loc) }
+	.debug_macinfo  0 : { *(.debug_macinfo) }
+	/* SGI/MIPS DWARF 2 extensions */
+	.debug_weaknames 0 : { *(.debug_weaknames) }
+	.debug_funcnames 0 : { *(.debug_funcnames) }
+	.debug_typenames 0 : { *(.debug_typenames) }
+	.debug_varnames  0 : { *(.debug_varnames) }
+	/* These must appear regardless of  .  */
+}
+
+__isIPL = 0;
+__stack_addr = (__bss_start + SIZEOF(.bss) + 0x80000 + 7) & (-8);
+__stack_end = (__bss_start + SIZEOF(.bss));
+__intrstack_addr = (__stack_addr + 0x4000);
+__intrstack_end = (__stack_addr);
+__Arena1Lo = (__intrstack_addr + 31) & (-32);
+__Arena1Hi = (0x816ffff0);
+__Arena2Lo = (0x90000800);
+__Arena2Hi = (0x933E0000);
+
+__gxregs = (__Arena1Hi + 31) & (-32);
+__ipcbufferLo = (0x933e0000);
+__ipcbufferHi = (0x93400000);
+
+/* for backward compatibility with old crt0 */
+PROVIDE (__stack = (0x816ffff0));
+
+PROVIDE(__isIPL = __isIPL);
+PROVIDE(__text_start = text_mem_start);
+PROVIDE(__text_fstart = text_file_start);
+PROVIDE(__data_start = data_mem_start);
+PROVIDE(__data_fstart = data_file_start);
+PROVIDE(__bss_start = bss_mem_start);
+PROVIDE(__bss_fstart = bss_file_start);
+PROVIDE(__stack_addr = __stack_addr);
+PROVIDE(__stack_end = __stack_end);
+PROVIDE(__intrstack_addr = __intrstack_addr);
+PROVIDE(__intrstack_end = __intrstack_end);
+PROVIDE(__Arena1Lo = __Arena1Lo);
+PROVIDE(__Arena1Hi = __Arena1Hi);
+PROVIDE(__Arena2Lo = __Arena2Lo);
+PROVIDE(__Arena2Hi = __Arena2Hi);
+PROVIDE(__ipcbufferLo = __ipcbufferLo);
+PROVIDE(__ipcbufferHi = __ipcbufferHi);
+PROVIDE(__gxregs = __gxregs);
Index: libvo/video_out.c
===================================================================
--- libvo/video_out.c	(revision 27458)
+++ libvo/video_out.c	(working copy)
@@ -113,6 +113,7 @@
 extern vo_functions_t video_out_quartz;
 extern vo_functions_t video_out_pnm;
 extern vo_functions_t video_out_md5sum;
+extern vo_functions_t video_out_gekko;
 
 const vo_functions_t* const video_out_drivers[] =
 {
@@ -219,6 +220,9 @@
 #endif
     &video_out_cvidix,
 #endif
+#ifdef GEKKO
+    &video_out_gekko,
+#endif
         &video_out_null,
 	// should not be auto-selected
 #ifdef HAVE_XVMC
Index: libvo/vo_gekko.c
===================================================================
--- libvo/vo_gekko.c	(revision 0)
+++ libvo/vo_gekko.c	(revision 0)
@@ -0,0 +1,217 @@
+/*
+   vo_gekko.c - MPlayer video driver for Wii
+
+   Copyright (C) 2008 dhewg
+
+   sepp256 - Added YUV frame rendering functions.
+
+   This library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2 of the License, or (at your option) any later version.
+
+   This library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with this library; if not, write to the
+   Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+   Boston, MA 02110-1301 USA.
+*/
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <errno.h>
+#include <malloc.h>
+
+#include "config.h"
+#include "mp_msg.h"
+#include "subopt-helper.h"
+#include "help_mp.h"
+#include "video_out.h"
+#include "video_out_internal.h"
+#include "mp_fifo.h"
+#include "osd.h"
+#include "sub.h"
+#include "osdep/keycodes.h"
+#include "osdep/log_console.h"
+#include "osdep/gx_supp.h"
+
+#include <gccore.h>
+
+static vo_info_t info = {
+	"gekko video output",
+	"gekko",
+	"Team Twiizers",
+	""
+};
+
+LIBVO_EXTERN(gekko)
+
+static int cam_pos_z = 350;
+
+static opt_t subopts[] = {
+	{ "cam_pos_z", OPT_ARG_INT,  &cam_pos_z, (opt_test_f) int_non_neg },
+	{ NULL }
+};
+
+static u8 *image_buffer[3] = { NULL, NULL, NULL };
+static u32 image_width = 0, image_height = 0;
+
+static void draw_alpha(int x0, int y0, int w, int h, unsigned char *src,
+						unsigned char *srca, int stride) {
+	vo_draw_alpha_yv12(w, h, src, srca, stride,
+						image_buffer[0] + (y0 * image_width + x0),
+						image_width);
+}
+
+static int draw_slice(uint8_t *image[], int stride[], int w, int h, int x,
+						int y) {
+	int i;
+	u8 *s[3], *d[3];
+
+	s[0] = image[0];
+	s[1] = image[1];
+	s[2] = image[2];
+	d[0] = image_buffer[0] + y * image_width + x;
+	d[1] = image_buffer[1] + y * image_width / 4 + x / 2;
+	d[2] = image_buffer[2] + y * image_width / 4 + x / 2;
+
+	for (i = 0; i < h; ++i) {
+		memcpy(d[0], s[0], w);
+		s[0] += stride[0];
+		d[0] += image_width;
+	}
+
+	for (i = 0; i < h / 2; ++i) {
+		memcpy(d[1], s[1], w / 2);
+		memcpy(d[2], s[2], w / 2);
+		s[1] += stride[1];
+		s[2] += stride[2];
+		d[1] += image_width / 2;
+		d[2] += image_width / 2;
+	}
+
+	return 0;
+}
+
+static void draw_osd(void) {
+	vo_draw_text(image_width, image_height, draw_alpha);
+}
+
+static void flip_page(void) {
+	u16 pitch[3];
+
+	pitch[0] = image_width;
+	pitch[1] = image_width / 2;
+	pitch[2] = image_width / 2;
+
+	GX_RenderYUV(image_width, image_height, image_buffer, pitch);
+}
+
+static int draw_frame(uint8_t *src[]) {
+	mp_msg(MSGT_VO, MSGL_ERR, "[VOGEKKO]: draw_frame\n");
+
+	return 0;
+}
+
+static int query_format(uint32_t format) {
+	switch (format) {
+	case IMGFMT_YV12:
+		return VFCAP_CSP_SUPPORTED | VFCAP_CSP_SUPPORTED_BY_HW |
+				VFCAP_HWSCALE_UP | VFCAP_HWSCALE_DOWN | VFCAP_ACCEPT_STRIDE;
+	default:
+		return 0;
+	}
+}
+
+static int config(uint32_t width, uint32_t height, uint32_t d_width,
+					uint32_t d_height, uint32_t flags, char *title,
+					uint32_t format) {
+	float sar, par;
+
+	if (image_buffer[0]) {
+		free(image_buffer[0]);
+		free(image_buffer[1]);
+		free(image_buffer[2]);
+		image_buffer[0] = NULL;
+		image_buffer[1] = NULL;
+		image_buffer[2] = NULL;
+	}
+
+	image_buffer[0] = (u8 *) malloc(width * height);
+	image_buffer[1] = (u8 *) malloc(width * height / 4);
+	image_buffer[2] = (u8 *) malloc(width * height / 4);
+
+	image_width = width;
+	image_height = height;
+
+	if (CONF_GetAspectRatio())
+		sar = 16.0f / 9.0f;
+	else
+		sar = 4.0f / 3.0f;
+
+	par = (float) d_width / (float) d_height;
+	par *= (float) vmode->fbWidth / (float) vmode->xfbHeight;
+	par /= sar;
+
+	if (par > sar) {
+		width = vmode->viWidth;
+		height = (float) width / par;
+	} else {
+		height = vmode->viHeight;
+		width = (float) height * par + vmode->viWidth - vmode->fbWidth;
+	}
+
+	mp_msg(MSGT_VO, MSGL_ERR, "[VOGEKKO]: SAR=%0.3f PAR=%0.3f %ux%u -> %ux%u\n",
+			sar, par, image_width, image_height, width, height);
+
+	GX_StartYUV(image_width, image_height, width / 2, height / 2);
+
+	return 0;
+}
+
+static void uninit(void) {
+	if (image_buffer[0]) {
+		free(image_buffer[0]);
+		free(image_buffer[1]);
+		free(image_buffer[2]);
+		image_buffer[0] = NULL;
+		image_buffer[1] = NULL;
+		image_buffer[2] = NULL;
+	}
+
+	image_width = 0;
+	image_height = 0;
+
+	//log_console_enable_video(true);
+}
+
+static void check_events(void) {
+}
+
+static int preinit(const char *arg) {
+	if (subopt_parse(arg, subopts) != 0)
+		mp_msg(MSGT_VO, MSGL_ERR, "[VOGEKKO]: ignoring unknown options: %s\n",
+				arg);
+
+	mp_msg(MSGT_VO, MSGL_ERR, "[VOGEKKO]: cam_pos_z=%d\n", cam_pos_z);
+
+	GX_SetCamPosZ(cam_pos_z);
+
+	log_console_enable_video(false);
+
+	return 0;
+}
+
+static int control(uint32_t request, void *data, ...) {
+	switch (request) {
+	case VOCTRL_QUERY_FORMAT:
+		return query_format(*((uint32_t*) data));
+	}
+
+	return VO_NOTIMPL;
+}
Index: libdvdcss/device.c
===================================================================
--- libdvdcss/device.c	(revision 27458)
+++ libdvdcss/device.c	(working copy)
@@ -52,9 +52,16 @@
 #if defined( WIN32 ) && !defined( SYS_CYGWIN )
 #   include <io.h>                                                 /* read() */
 #else
+#ifndef GEKKO
 #   include <sys/uio.h>                                      /* struct iovec */
 #endif
+#endif
 
+#ifdef GEKKO
+#    include <di/di.h>
+#    include <malloc.h>
+#endif
+
 #ifdef DARWIN_DVD_IOCTL
 #   include <paths.h>
 #   include <CoreFoundation/CoreFoundation.h>
@@ -81,6 +88,13 @@
 static int libc_read  ( dvdcss_t, void *, int );
 static int libc_readv ( dvdcss_t, struct iovec *, int );
 
+#ifdef GEKKO
+static int di_open  ( dvdcss_t, char const * );
+static int di_seek  ( dvdcss_t, int );
+static int di_read  ( dvdcss_t, void *, int );
+static int di_readv ( dvdcss_t, struct iovec *, int );
+#endif
+
 #ifdef WIN32
 static int win2k_open ( dvdcss_t, char const * );
 static int aspi_open  ( dvdcss_t, char const * );
@@ -95,6 +109,7 @@
 
 int _dvdcss_use_ioctls( dvdcss_t dvdcss )
 {
+#ifndef GEKKO
 #if defined( WIN32 )
     if( dvdcss->b_file )
     {
@@ -144,6 +159,9 @@
         return 0;
     }
 #endif
+#else
+	return 0;
+#endif
 }
 
 void _dvdcss_check ( dvdcss_t dvdcss )
@@ -270,6 +288,10 @@
     }
 
     IOObjectRelease( media_iterator );
+#elif defined GEKKO
+    free( dvdcss->psz_device );
+    dvdcss->psz_device = strdup("/dev/di");
+    print_debug( dvdcss, "defaulting to drive `%s'", dvdcss->psz_device );
 #else
     for( i = 0; ppsz_devices[i]; i++ )
     {
@@ -294,6 +316,15 @@
 
     print_debug( dvdcss, "opening target `%s'", psz_device );
 
+#ifdef GEKKO
+    print_debug( dvdcss, "using Erant's DI API for access" );
+
+    dvdcss->pf_seek = di_seek;
+    dvdcss->pf_read = di_read;
+    dvdcss->pf_readv = di_readv;
+
+    return di_open( dvdcss, psz_device );
+#else
 #if defined( WIN32 )
     dvdcss->b_file = 1;
     /* If device is "X:" or "X:\", we are not actually opening a file. */
@@ -330,6 +361,7 @@
         dvdcss->pf_readv = libc_readv;
         return libc_open( dvdcss, psz_device );
     }
+#endif
 }
 
 #ifndef WIN32
@@ -382,6 +414,10 @@
     }
 
     return 0;
+#elif defined GEKKO
+	print_debug(dvdcss, "DI: deinitializing dvd...");
+	DI_StopMotor();
+	DI_Close();
 #else
     close( dvdcss->i_fd );
 
@@ -971,3 +1007,124 @@
 }
 #endif
 
+#ifdef GEKKO
+static int di_open(dvdcss_t dvdcss, char const * psz_device) {
+	int retry = 20 * 5;
+	int status;
+
+	if (strcmp(psz_device, "/dev/di")) {
+		print_debug(dvdcss, "DI: unknown device '%s'", psz_device);
+		return -1;
+	}
+
+	print_debug(dvdcss, "DI: initializing dvd...");
+	DI_Mount();
+
+	print_debug(dvdcss, "DI: waiting for device to become ready...");
+
+	while (retry > 0) {
+		status = DI_GetStatus();
+
+		if (!(status & DVD_INIT))
+			break;
+		
+		retry--;
+		
+		usleep (200 * 1000);
+	}
+
+	if (status & DVD_NO_DISC) {
+		print_debug(dvdcss, "DI: no disc, dude");
+		DI_Close();
+		return -1;
+	}
+
+	if (!(status & DVD_READY)) {
+		print_debug(dvdcss, "DI: dvd not ready: 0x%x", status);
+		DI_Close();
+		return -1;
+	}
+
+	if (status & DVD_D0)
+		print_debug(dvdcss, "DI: no modchip detected");
+
+	if (status & DVD_A8)
+		print_debug(dvdcss, "DI: modchip detected");
+
+	dvdcss->i_pos = 0;
+
+	return 0;
+}
+
+static int di_seek(dvdcss_t dvdcss, int i_blocks) {
+	if (dvdcss->i_pos == i_blocks )
+		return i_blocks;
+
+	//TODO check this against the disc's max lba
+	dvdcss->i_pos = i_blocks;
+	return dvdcss->i_pos;
+}
+
+static int di_read(dvdcss_t dvdcss, void *buffer, int blocks) {
+	void *bfr;
+	int ret;
+
+	bfr = memalign(32, blocks * DVDCSS_BLOCK_SIZE);
+	if (bfr == NULL) {
+		print_debug(dvdcss, "DI: can't allocate %d bytes",
+					blocks * DVDCSS_BLOCK_SIZE);
+		return -1;
+	}
+
+	ret = DI_ReadDVD(bfr, blocks, dvdcss->i_pos);
+
+	if (ret < 0) {
+		print_debug(dvdcss, "DI: read failed with %d", ret);
+		free(bfr);
+		return -1;
+	}
+
+	dvdcss->i_pos += blocks;
+	memcpy(buffer, bfr, blocks * DVDCSS_BLOCK_SIZE);
+	free(bfr);
+
+	return blocks;
+}
+
+static int di_readv(dvdcss_t dvdcss, struct iovec *iov, int iovcnt) {
+	int len;
+	int i;
+	int ret;
+	void *bfr, *ptr;
+
+	len = 0;
+	for (i = 0; i < iovcnt; ++i)
+		len += iov[i].iov_len;
+
+	bfr = memalign(32, len);
+	if (bfr == NULL) {
+		print_debug(dvdcss, "DI: can't allocate %d bytes",
+					len * DVDCSS_BLOCK_SIZE);
+		return -1;
+	}
+
+	ret = DI_ReadDVD(bfr, len / DVDCSS_BLOCK_SIZE, dvdcss->i_pos);
+	if (ret < 0) {
+		print_debug( dvdcss, "DI: readv failed with %d", ret);
+		free(bfr);
+		return -1;
+	}
+
+	ptr = bfr;
+	for (i = 0; i < iovcnt; ++i) {
+		memcpy(iov[i].iov_base, ptr, iov[i].iov_len);
+		ptr += iov[i].iov_len;
+	}
+
+	dvdcss->i_pos += len / DVDCSS_BLOCK_SIZE;
+	free(bfr);
+
+	return len;
+}
+#endif
+
Index: libdvdcss/device.h
===================================================================
--- libdvdcss/device.h	(revision 27458)
+++ libdvdcss/device.h	(working copy)
@@ -30,10 +30,12 @@
 #   include <io.h>                                                 /* read() */
 #else
 #   include <sys/types.h>
+#ifndef GEKKO
 #   include <sys/uio.h>                                      /* struct iovec */
 #endif
+#endif
 
-#if defined( WIN32 ) && !defined( SYS_CYGWIN )
+#if ( defined( WIN32 ) && !defined( SYS_CYGWIN ) ) || defined ( GEKKO )
 struct iovec
 {
     void *iov_base;     /* Pointer to data. */
